<?php

/*************************************************************

 File: config.php3
 Author: didi
 Revision: 2.0.0
 Date: 1999/05/18

 This file contains the configuration of the
 makeforward.php3 and makevacation.php3 scripts.
 
 php-mailsetting:
 Copyright 1999 Dietmar Rieder <adrieder@sbox.tu-graz.ac.at>
 
 You should have received a copy of the GNU Public
 License along with this package; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.

 ***************************************************************/

/*
  Language settings
 */
$default->lang = "de";		/* default language (de/en) */

/*
  GD support in php_module
 */
$default->gd_support  = true;   /* is the libdg compiled in in my mod_php  */

/*
   Network definitions
 */
$default->mail_domain = "sbox.tu-graz.ac.at";		/* maildomain  */
$default->imap_host   = "localhost";			/* imap-host   */
$default->imap_port   = 143;				/* imap-port   */
$default->ldap_host   = "nfsgate.tu-graz.ac.at";	/* ldap-host   */
$default->ldap_port   = 389;				/* ldap-port   */

/*
  Authentication - type (ldap/imap)
 */
$default->auth_type = "ldap";                       /* authenticate through ldap or imap */

/*
  Bindstring for the ldap-authentication
 */
$default->bind_str = "cn=$username, ou=$username[0], ou=studenten, ou=dienste, o=tu-graz";

/* 
   System files
 */
$default->aliases_file = "/etc/mail/aliases/users";			/* aliases file  */
$default->new_aliases  = "/var/imap/newaliases";			/* newaliases programm */
$default->status_dir   = "/var/forward/status";				/* forward status directory */
$default->status_file  = "$default->status_dir/$username";		/* forward status file of the current user */
$default->tmp_dir      = "/var/forward/tmp";				/* temporary directory for authentication status */
$default->auth_ok_file = "$default->tmp_dir/$username";			/* authentication status file */
$default->vac_template = "/etc/mail/vacation.templ";			/* vacation message template-file*/
$default->vac_dir      = "/var/vacation";				/* vacation stuff directory  */
$default->vac_prog     = "/usr/local/bin/vacation.pl"; 			/* vacation program  */
$default->logfile      = "/var/log/mailsettings.log";			/* logfile where the actions are logged */

/* 
   Errors & debugging 
 */
$default->debug_stat      = false;		/* debugging status */
$default->error_level     = 0;			/* level of error reporting (0-15) */

/*
  Cache control
 */
$default->expire_time     = 300;		/* time in seconds after which expires the output */

/*
  Dircetory & includes
 */
$default->base_dir        = "settings"	;		/* base dir of forward relative to the apache-htdoc base */
$default->login           = "login.html";		/* html file for the login dialog */
$default->include_dir     = "includes";			/* directory containing the include files */
$default->status_int      = "status.inc";		/* include file: show forward status */
$default->change_int      = "interface_change.inc";	/* include file: changing the forward entry  */
$default->new_int         = "interface_new.inc";	/* include file: adding a forward entry */
$default->mailbox	  = "mailbox.inc";		/* include file: show the mailboxinfo  */
$default->vacation_int	  = "vacation.inc";		/* include file: show the vacation dialog  */
$default->login_incorrect = "login_incorrect.inc";	/* include file: login incorrect */
$default->login_timed_out = "login_timed_out.inc";	/* include file: login timed out */
$default->invalid_addr    = "invalid_addr.inc";		/* include file: invalid email-address */
$default->error           = "error.inc";		/* include file: error ocurred */
$default->error_vac       = "error_vac.inc";		/* include file: error ocurred */
$default->success         = "success.inc";		/* include file: opreation succeded */
$default->success_vac     = "success_vac.inc";		/* include file: opreation succeded */
$default->header          = "header.inc";		/* include file: html header */
$default->footer          = "footer.inc";		/* include file: html footer */

/*
  Restrictions
 */
$default->timeout         = 300;		/* time in seconds after which the user-login times out */

/*
  Mailbox settings
 */
$default->mbox_name       = "INBOX";		/* name of the imap-mailbox to check   */
$default->mbox_quota      = 15000;		/* qouta of the user mailbox in kbytes */
$default->qouta_warn      = 90;			/* percentage of quota above which users will be warned */

/*
  Features (enable/disable = true/false)
 */
$default->feature_local_copy     = true;	/* allow local-copy entry on forwarding */
$default->feature_show_mbox_info = true;	/* show mailbox info on login */ 
$default->feature_vacation       = true; 	/* enable/disable vacation feature */

/* Don't insert anything below this line  */
?>