#!/usr/local/bin/perl
#############################################################################
#
# Auto Responder TU-Graz
#
# File: vacation.pl
# Author: Ray Chan 29 March 1998
#         Friedrich Lobenstock <fl@fl.priv.at>
#	  Dietmar Rieder
# Revision: 1.0.0
# Date: 1999/05/18
#
# vacation.pl:
# Copyright 1999 Dietmar Rieder <adrieder@sbox.tu-graz.ac.at>
#           1998 Ray Chan (http://home.hkstar.com/~west/perl98/html/aack.html)
#
# You should have received a copy of the GNU Public
# License along with this package; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.
#
#
#############################################################################
#
# Setup Section
#

$conf='/etc/mail/vacation.conf';

require 5.0;
require "$conf";

##############################################################################
# End of Setup Section
##############################################################################

if (@ARGV <= 0) {
	print "no user\n";
	exit 1;
}

$user= $ARGV[0];


# init 
$reply_message="$message_dir/$user.msg";
$safelog = "$safelog/$user";

@orgmail=<STDIN>;

#find incoming mail's =>from, subject, date, reply-to

$REPLY="";
$NAME="";
$FROM="";
$SUBJECT="";
$DATE="";
$PRECEDENCE="";

# temp var for header checking
$t_rto=0;
$t_from=0;
$t_sub=0;
$t_date=0;
$t_prec=0;
$t_fin=0;

foreach $each (@orgmail){
	if ( (t_fin>=5) || ($each =~ /^$/ ) )    {
		break;
	}
	if ($each =~ /Reply-To: / && $t_rto == 0){
		$REPLY=$each;
		chomp($REPLY);
		$t_rto=1;
		$t_fin=$t_fin+1;
	}
        if ($each =~ /From: / && $t_from == 0){
                $NAME=$each;
		chomp($NAME);
		$t_from=1;
		$t_fin=$t_fin+1;
        }
        if ($each =~ /Subject: / && $t_sub == 0){
                $SUBJECT =$each;
		chomp($SUBJECT);
		$t_sub=1;
		$t_fin=$t_fin+1;
        }
        if ($each =~ /Date: / && $t_date == 0){
                $DATE=$each;
		chomp($DATE);
		$t_date=1;
		$t_fin=$t_fin+1;
        }  
        if ($each =~ /Precedence: / && $t_prec == 0){
                $PRECEDENCE=$each;
		chomp($PRECEDENCE);
		$t_prec=1;
		$t_fin=$t_fin+1;
        }  
}

# pharse the variable in actual form

$NAME=~s/From: //;
$SUBJECT=~s/Subject: //;
$DATE=~s/Date: //;
$REPLY=~s/Reply-To: //;
$PRECEDENCE=~s/Precedence: //;
$PRECEDENCE=~tr/A-Z/a-z/;

# if this mail is from a mailing list PRECEDENCE
# is either 'list', 'junk' or 'bulk'

if (    ($PRECEDENCE ne "")
     && (    ($PRECEDENCE eq "list")
          || ($PRECEDENCE eq "junk")
          || ($PRECEDENCE eq "bulk")
        )
   ) {

     # no need to send anything

     #append to full log
     if ($fulllogit == 1){
        $date=localtime();
     	if (!open (Log, ">>$fulllogurl") ) {
          system ( "/usr/bin/logger -p error -t vacation -i Can not open $fulllogurl for logging");
          system ( "/usr/bin/logger -p alert -t vacation -i Can not open $fulllogurl for logging");
          exit 1;
        } 
        if ( $REPLY eq "" ) {
             $REPLY = $FROM;
        }
        print Log "$date : $user -> $REPLY not sent (mailing list)\n";
        close (Log);
     }

     exit 0;
}


#First get the actual name and address
$INNAME=$NAME;
&get_address;
$FROM=$TFROM;

#Then get the actual reply address
if ($replyto == 0){
	$REPLY=$FROM;
}

if ($REPLY eq ""){
	$REPLY=$FROM;
}

if ($replyto == 1 && $REPLY eq ""){
	$REPLY=$FROM;
}

if ($replyto == 1 && $REPLY ne ""){
	$INNAME=$REPLY;
	&get_address;
	if ($flag==1){
		$REPLY=$TFROM;
	}
	if ($flag == 0){
		#reply-to does not have valid address, try 'from' instead
		$REPLY=$FROM;
	}
}


#check if the mail was sent from MAILER-DAEMON
$doit=0;

if ($FROM =~ /mailer-daemon/i){
	$doit=1;
}

if ($checkdomain == 1){
        #check if the reply address's domain is a valid address

        $tochk = $REPLY;
        $tochk =~ s/ //g;
        $tochk =~ s/.*@\b//;

        $exornot = `whois -h rs0.internic.net $tochk`;

        if ($exornot =~ /no match/i){ #no such domain registered
        	$doit=1;
        }
}

if ($doit==0){ #$doit=0, pass checked

#now assign $doit=1=really do it 
#find the reply file

# check if the incoming message is sent by myself
# if yes, never response to the message 

$rfrom=~tr/A-Z/a-z/;
$rfrom= $user . $rfrom;

if ( !open (DATAFILE, "<$reply_message") ) {
  system ( "/usr/bin/logger -p error -t vacation -i Can not open $reply_message for reading");
  system ( "/usr/bin/logger -p alert -t vacation -i Can not open $reply_message for reading");
  exit 1;
} 
@DATA=<DATAFILE>;
close(DATAFILE);

$flag=0;	#$flag=0=doit 	$flag=1=fail check

# check if we already sent a notification to this user


# get log's data
open (Log, "<$safelog");
@data=<Log>;
close (Log); 

if ( grep /^$REPLY/, @data ) {
     # we already sent a notification to this user!
     $flag=1;
} 

if ($flag==0){
foreach $item (@DATA){
	#replace macro to actual data
        if ($item =~ /\$FROM/){
        	$item=~s/\$FROM/$FROM/;
       	}
       	if ($item =~ /\$NAME/){
             	$item=~s/\$NAME/$NAME/;
        }
       	if ($item =~ /\$SUBJECT/){
               	$item=~s/\$SUBJECT/$SUBJECT/;
        }
        if ($item =~ /\$DATE/){
               $item=~s/\$DATE/$DATE/;
        }
        if ($item =~ /\$USER/){
               $item=~s/\$USER/$user/;
        }
}

$date=localtime();


#get the subject from data file

($rsubject) = @DATA;
chomp($rsubject);
$tmp = @DATA;
$tmp = $tmp - 1;
@DATA=@DATA[1..$tmp];

#start sendmail mail
open(MAIL, "|$mail -t -f $rfrom");
print MAIL "From: $rfrom\n";
print MAIL "To: $REPLY\n";
print MAIL "Subject: $rsubject\n";
print MAIL "Precedence: Bulk\n";
print MAIL "\n";
print MAIL (@DATA);
print MAIL "\n------ mail sent through the autoresponder on sbox.tu-graz.ac.at -------\n";
close (MAIL);

#add to safe log
if ( !open (Log, ">>$safelog" ) ) {
  system ( "/usr/bin/logger -p error -t vacation -i Can not open $safelog for logging");
  system ( "/usr/bin/logger -p alert -t vacation -i Can not open $safelog for logging");
  exit 1;
} 
print Log "$REPLY - $date\n";
close (Log);

#append to full log
if ($fulllogit == 1){
	if ( !open (Log, ">>$fulllogurl") ) {
          system ( "/usr/bin/logger -p error -t vacation -i Can not open $fulllogurl for logging");
          system ( "/usr/bin/logger -p alert -t vacation -i Can not open $fulllogurl for logging");
	  exit 1;
        }
 
        print Log "$date : $user -> $REPLY\n";
  	close (Log);
}

} #end of $flag==0 (pass the max hit test)
} #end of $doit==1 (loop which check for mail from MAILER-DAEMON)

sub get_address{

$flag = 0;

#case 1, sender field format: From: Name <addreess@domain.net>
if ($INNAME =~ /</ && $INNAME =~ />/){
        ($NAME,$TFROM)=split(/</,$INNAME);
        $TFROM=~s/>//;
        $TFROM =~ tr/A-Z/a-z/;
        $TFROM =~ s/ //g;
        $flag=1;
}  

#case 2, sender field format: From: address@domain.net
if ($flag==0){
        if ($INNAME =~ /@/){
                $TFROM = $INNAME;
                $TFROM =~ tr/A-Z/a-z/;
                $TFROM =~ s/ //g;
                $flag=1;
        }
}

#remove comments from address (...)
if ($TFROM =~ /\(/ && $TFROM=~ /\)/){
	$TFROM=~s/\(.*\)//g;
}

}
